#ifndef AUTOIMPORT_H
#define AUTOIMPORT_H

#include <QObject>
#include <QFileSystemWatcher>
#include <QTimer>
#include <QMap>

#include "QNNTPGrabGlue.h"

class MainWindow;   /* Prevent recursion */

class AutoImport : public QObject
{
    Q_OBJECT

public:
    AutoImport(MainWindow *mainwindow, QNNTPGrabGlue *glue);

    void enableWatch(QString path);
    void disableWatch();

private:
    QNNTPGrabGlue *glue;
    MainWindow *mainwindow;
    QFileSystemWatcher watcher;
    QString path;
    QTimer fileReadyTimer;
    QMap<QString,QDateTime> filesQueued;

    void doImport(QString path);

private slots:
    void directoryChanged(QString path);
    void fileReadyTimer_timeout();

    void onPluginEvent(QString plugin_name, QString event_name, QList<QString> args);
};

#endif // AUTOIMPORT_H
